// CfgDlg.cpp : implementation file
//

// CheckMail 1.0
// Free source code
//
// Author: German Madyarov
// mga@kbb.kemerovo.su,rusboy_mga@hotmail.com
// http://mga.webjump.com

#include "stdafx.h"
#include "chkmail.h"
#include "CfgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCfgDlg dialog

extern unsigned int m_timeout;
extern CString m_wave;
extern CString m_command;
extern CString m_address;
extern BOOL m_forward;

CCfgDlg::CCfgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCfgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCfgDlg)
	m_newtimeout = 0;
	m_newwave = _T("");
	m_newcommand = _T("");
	m_newredirect = FALSE;
	m_newaddress = _T("");
	//}}AFX_DATA_INIT
}


void CCfgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCfgDlg)
	DDX_Control(pDX, IDC_EDIT4, m_newadredit);
	DDX_Text(pDX, IDC_EDIT1, m_newtimeout);
	DDX_Text(pDX, IDC_EDIT2, m_newwave);
	DDX_Text(pDX, IDC_EDIT3, m_newcommand);
	DDX_Check(pDX, IDC_CHECK1, m_newredirect);
	DDX_Text(pDX, IDC_EDIT4, m_newaddress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCfgDlg, CDialog)
	//{{AFX_MSG_MAP(CCfgDlg)
	ON_BN_CLICKED(IDC_CHANGEWAVE, OnChangewave)
	ON_BN_CLICKED(IDC_CHANGECOMM, OnChangecomm)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCfgDlg message handlers

void CCfgDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	if( m_newredirect && m_newaddress.IsEmpty())
	{
		MessageBox("   e-mail   -\n  -","!",MB_ICONINFORMATION);
		return;
	}
	m_timeout=m_newtimeout*1000;
	AfxGetApp()->WriteProfileInt("Setting","timeout",m_timeout);
	m_wave=m_newwave;
	AfxGetApp()->WriteProfileString("Setting","sound",m_wave);
	m_command=m_newcommand;
	AfxGetApp()->WriteProfileString("Setting","command",m_command);
	m_forward=m_newredirect;
	AfxGetApp()->WriteProfileInt("Setting","forward",m_forward);
	m_address=m_newaddress;
	AfxGetApp()->WriteProfileString("Setting","forward address",m_address);
	
	CDialog::OnOK();
}

BOOL CCfgDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_newtimeout=m_timeout/1000;
	m_newwave=m_wave;
	m_newcommand=m_command;
	m_newredirect=m_forward;
	if(m_newredirect)
		m_newadredit.EnableWindow(TRUE);
	else
		m_newadredit.EnableWindow(FALSE);
		
	m_newaddress=m_address;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCfgDlg::OnChangewave() 
{
	CFileDialog fdlg(TRUE,"wav",NULL,OFN_PATHMUSTEXIST,"Wave Sound(*.wav)|*.wav||",this);
	if( fdlg.DoModal()==IDOK )
	{
		m_newwave=fdlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CCfgDlg::OnChangecomm() 
{
	CFileDialog fdlg(TRUE,"EXE",NULL,OFN_PATHMUSTEXIST,"Application|*.exe||",this);
	if( fdlg.DoModal()==IDOK )
	{
		m_newcommand=fdlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CCfgDlg::OnCheck1() 
{
	UpdateData(TRUE);

	if(m_newredirect)
	{
		m_newadredit.EnableWindow(TRUE);
		m_newadredit.SetFocus();
	}
	else
		m_newadredit.EnableWindow(FALSE);
}
