// chkmailDlg.cpp : implementation file
//

#include "stdafx.h"
#include "chkmail.h"
#include "chkmailDlg.h"

#include "Mmsystem.h"

#include "Pop3Client.h"
#include "SmtpClient.h"

#include "ViewLogDlg.h"
#include "ConfigSheet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CChkmailDlg dialog

CChkmailDlg::CChkmailDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChkmailDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChkmailDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChkmailDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChkmailDlg)
	DDX_Control(pDX, IDC_COPYRIGHT, m_copyright);
	DDX_Control(pDX, IDC_RESUME, m_resume);
	DDX_Control(pDX, IDC_REF, m_ref);
	DDX_Control(pDX, IDC_TITLE, m_title);
	DDX_Control(pDX, IDC_LOGO, m_logo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChkmailDlg, CDialog)
	//{{AFX_MSG_MAP(CChkmailDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_LOGO, OnLogo)
	ON_BN_CLICKED(IDC_REF, OnRef)
	ON_BN_CLICKED(IDC_RESUME, OnResume)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER+43,OnTrayNotify)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChkmailDlg message handlers

BOOL CChkmailDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//   
	SetWindowText("Checkmail 2.0");

	m_title.m_bktransparent=TRUE;
	m_title.SetColor(RGB(0,0,255),RGB(0,0,0));
	m_title.SetLabelFont(36,TRUE,TRUE);

	m_ref.m_bktransparent=TRUE;
	m_ref.SetColor(RGB(0,0,255),RGB(0,0,0));
	m_ref.SetLabelFont(14,TRUE,FALSE,TRUE);
	m_ref.SetLabelCursor(IDC_HANDCURSOR);
	
	m_resume.SetColor(RGB(255,255,255),RGB(0,0,255));
	m_resume.SetLabelFont(14,TRUE);
	m_resume.SetLabelCursor(IDC_HANDCURSOR);

	m_copyright.m_bktransparent=TRUE;
	m_copyright.SetColor(RGB(0,0,255),RGB(0,0,255));
	m_copyright.SetLabelFont(14,TRUE);
	
	//  WinSock 2
	WSAData wsaData;
	if( WSAStartup(0x202,&wsaData)==SOCKET_ERROR )
	{
		m_string.Format("WSAStartup failed with error ",WSAGetLastError());
		MessageBox(m_string,"CheckMail",MB_SYSTEMMODAL|MB_ICONEXCLAMATION);
		EndDialog(0);
		return FALSE;
	}

	m_lastcount=0;	//  (   ) 
	m_isbusy=FALSE;	//    CheckMail()

	//     SysTray
	m_nf.cbSize=sizeof(NOTIFYICONDATA);
	m_nf.hIcon=m_hIcon;
	m_nf.uFlags=NIF_ICON|NIF_MESSAGE|NIF_TIP;
	m_nf.uCallbackMessage=WM_USER+43;
	m_nf.hWnd=GetSafeHwnd();
	m_nf.uID=123;
	memset(m_nf.szTip,0,sizeof(m_nf.szTip));
	strcpy(m_nf.szTip,"  ( ) ");
	Shell_NotifyIcon(NIM_ADD,&m_nf);

	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1); // 
	
	//     .
	LoadSetting();
	//      
	SetTimer(2,m_timeout,NULL);

	// , ""  
	SetTimer(1,10,NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChkmailDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		//      

		CPaintDC dc(this); // device context for painting
		
		CDC memDC;
		memDC.CreateCompatibleDC(&dc);

		CRect rectangle;
		GetClientRect(rectangle);
		int nWidth = rectangle.Width(); 
		int nHeight = rectangle.Height();

		CBitmap bm;
		bm.CreateCompatibleBitmap(&dc,nWidth,nHeight);
		memDC.SelectObject(&bm);

		for(int i = 0; i < nHeight; ++i) // Fill in strip
		{
			rectangle.SetRect(0, i, nWidth, i + 1);
			memDC.FillSolidRect(&rectangle, 
				RGB(0,0,255 - MulDiv(i, 255, nHeight)));
		}
		
		dc.BitBlt(0,0,nWidth,nHeight,&memDC,0,0,SRCCOPY);

	}
}

void CChkmailDlg::OnTimer(UINT nIDEvent)
{
	if(nIDEvent==2)
	{
		if( !m_isbusy && !m_server.IsEmpty() 
			&& !m_user.IsEmpty() && !m_pass.IsEmpty() )
		{
			CheckMail();
			return;
		}
	}
	
	//     
	if(nIDEvent==1)
	{
		KillTimer(1);
		ShowWindow(SW_HIDE);
		return;
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChkmailDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CChkmailDlg::OnTrayNotify(WPARAM wParam, LPARAM lParam)
{
	if( wParam==123 && lParam==WM_RBUTTONDOWN )
	{
		//  PopupMenu " "
		HMENU m_hPopupMenu=CreatePopupMenu();
		
		AppendMenu(m_hPopupMenu,MF_STRING,3,"");
		if( m_server.IsEmpty() || m_user.IsEmpty() || m_pass.IsEmpty() )
			//    ,   
			AppendMenu(m_hPopupMenu,MF_GRAYED,4," ");
		else
			AppendMenu(m_hPopupMenu,MF_STRING,4," ");
	
		if( m_writelog &&(!m_logfile.IsEmpty()))
			AppendMenu(m_hPopupMenu,MF_STRING,5," ");	
		else
			AppendMenu(m_hPopupMenu,MF_GRAYED,5," ");
				
		AppendMenu(m_hPopupMenu,MF_SEPARATOR,0,"");
		AppendMenu(m_hPopupMenu,MF_STRING,2," ");
		AppendMenu(m_hPopupMenu,MF_SEPARATOR,0,"");
		AppendMenu(m_hPopupMenu,MF_STRING,1,"");
		
		POINT p;
		GetCursorPos(&p);
		
		SetForegroundWindow();
		int m_idMenu=TrackPopupMenu(m_hPopupMenu,
			TPM_RIGHTALIGN | TPM_BOTTOMALIGN | 
			TPM_LEFTBUTTON | TPM_RETURNCMD,
			p.x,p.y,0,GetSafeHwnd(),NULL);
		PostMessage(WM_NULL);
		
		DestroyMenu(m_hPopupMenu);

		//   
		if( m_idMenu==1 )
		{
			EndDialog(0); //   
			return;
		}
		if( m_idMenu==2 )
		{
			ShowWindow(SW_SHOW);	//  " "
			return;
		}		
		if( m_idMenu==3 )
		{
			OnConfig();
			return;
		}
		
		if( m_idMenu==4 )
		{
			//    
			if( !m_isbusy )
				CheckMail();
			return;
		}
		
		if( m_idMenu==5 )
		{
			ViewLog();
			return;
		}
	}

	if (wParam==123 && lParam==WM_LBUTTONDOWN)		
	{
		//    
		
		//    ,   
		if( m_lastcount==0 )
		{
			if( !m_isbusy && !m_server.IsEmpty() 
				&& !m_user.IsEmpty() && !m_pass.IsEmpty() )
				CheckMail();
			return;
		}
		
		//   ,   ,
		//    
		if(!m_command.IsEmpty())
			ShellExecute(NULL,"Open",m_command,NULL,
				NULL,SW_SHOWNORMAL);
	}
}

void CChkmailDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	
	//    :
	
	//   log-file,    
	if (logfile.m_pStream != NULL)
	{
		logfile.Close();
		::DeleteFile(m_logfile);
	}
	// - WinSock
	WSACleanup();
	//    SysTray
	Shell_NotifyIcon(NIM_DELETE,&m_nf);	
}

//   
void CChkmailDlg::CheckMail()
{
	m_isbusy=TRUE;	//   "  "
	
	//       POP3
	CPop3Client pop; 
	
	CString textbuffer;
	//   
	if( !pop.Connect(m_server,m_portPOP) ) 
	{
		textbuffer.Format("Unable connect to POP-server %s on port %d",m_server,m_portPOP);
		WriteLog(textbuffer);
		WriteLog(pop.GetMessage(),FALSE);
		WriteLog("",FALSE);

		m_isbusy=FALSE;
		return;
	}
	//      
	if( !pop.Login(m_user,m_pass) )
	{
		pop.Disconnect();
	
		WriteLog("Unable login to POP-server as "+m_user);
		WriteLog(pop.GetMessage(),FALSE);
		WriteLog("",FALSE);

		m_isbusy=FALSE;
		return;
	}

	//   ,  .  SysTray  .
	if( pop.m_messcount==0 )
	{
		m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
		m_nf.hIcon=m_hIcon;
		strcpy(m_nf.szTip,"  ( ) ");
		Shell_NotifyIcon(NIM_MODIFY,&m_nf);
		m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);
		pop.Disconnect();
		m_lastcount=0;
		m_isbusy=FALSE;
		return;
	}

	//   ( . )  , 
	if( pop.m_messcount==m_lastcount )
	{
		pop.Disconnect();
		m_isbusy=FALSE;
		return;
	}
	
	//    (m_messcount-m_lastcount )
	char tooltip[64];
	memset(tooltip,0,64);
	strcpy(tooltip,"   (");
	
	char buf[5];
	itoa(pop.m_messcount,buf,10);
	strcat(tooltip,buf);
	strcat(tooltip,")  ");
	
	m_nf.hIcon=m_hIcon;
	strcpy(m_nf.szTip,tooltip);
	Shell_NotifyIcon(NIM_MODIFY,&m_nf);

	textbuffer.Format("   (%d)",pop.m_messcount-m_lastcount);
	WriteLog(textbuffer);
	WriteLog("",FALSE);

	//    "  "  ""
	if( m_forward || m_pager )
	{
		CSmtpClient smtp;
		//   SMTP-
		if( smtp.Connect(m_serverSmtp,m_portSmtp,"CheckMail") )
		{
			int m_messsize=0;
			char* m_messbody=NULL;
			for(unsigned int i=m_lastcount;i<pop.m_messcount;i++)
			{
				m_messsize=pop.GetMessageSize(i+1);
				m_messbody=(char*)malloc(m_messsize+4096);
				
				//     
				if( m_pager && !m_pageraddress.IsEmpty() && !m_pagerid.IsEmpty())
				{
					memset(m_messbody,0,m_messsize+4096);

					textbuffer="Subject:"+m_pagerid;
					char* pagerid=(char*)malloc(textbuffer.GetLength()+3);
					strcpy(pagerid,textbuffer);
					memcpy(pagerid+textbuffer.GetLength(),"\r\n",2);

					memcpy(m_messbody,pagerid,textbuffer.GetLength()+2);
					free(pagerid);
				
					if(!pop.Retr(i+1,m_messbody+textbuffer.GetLength()+2))			
					{
						textbuffer.Format("Command Retr %d is failed",i+1);
						WriteLog(textbuffer);
						WriteLog(pop.GetMessage(),FALSE);
					}
				
					if( !smtp.SendMail("forward@checkmail.ru",m_pageraddress,m_messbody,m_messsize+strlen(pagerid)))
					{
						textbuffer.Format("Forward message #%d is failed",i+1);
						WriteLog(textbuffer);
						WriteLog(smtp.GetMessage(),FALSE);
					}
					textbuffer.Format("Message %d is sended to %s with Subject:%s",i+1,m_pageraddress,m_pagerid);
					WriteLog(textbuffer);
					WriteLog("",FALSE);
				}
				//  forward-  

				//     email
				if( m_forward && !m_address.IsEmpty() )
				{
					memset(m_messbody,0,m_messsize+4096);
					
					if(!pop.Retr(i+1,m_messbody))
					{
						textbuffer.Format("Command Retr %d is failed",i+1);
						WriteLog(textbuffer);
						WriteLog(pop.GetMessage(),FALSE);
					}

					if( !smtp.SendMail("forward@checkmail.ru",m_address,m_messbody,m_messsize))
					{
						textbuffer.Format("Forward message #%d is failed",i+1);
						WriteLog(textbuffer);
						WriteLog(smtp.GetMessage(),FALSE);
					}
					textbuffer.Format("Message %d is forwarded to %s",i+1,m_address);
					WriteLog(textbuffer);
					WriteLog("",FALSE);
				}
				//  forward-   email

				free(m_messbody);
			}
		}
		else
		{
			//    SMTP-  
			textbuffer.Format("Unable connect to SMTP-server %s on port %d",m_serverSmtp,m_portSmtp);
			WriteLog(textbuffer);
			WriteLog(smtp.GetMessage(),FALSE);
			WriteLog("",FALSE);
		}
	}


	m_lastcount=pop.m_messcount;

	m_isbusy=FALSE;

	//   POP3 
	pop.Disconnect();
	//   "  "
	PlaySound(m_wave,NULL,SND_FILENAME);

	if( !m_shedprog.IsEmpty() )
		ShellExecute(NULL,"Open",m_shedprog,NULL,
				NULL,SW_SHOWNORMAL);

}

//         
void CChkmailDlg::OnLogo() 
{
	ShellExecute(NULL,"Open","http://mgasoft.0catch.com",NULL,NULL,SW_MAXIMIZE);	
}

//         
void CChkmailDlg::OnRef() 
{
	ShellExecute(NULL,"Open","http://mgasoft.0catch.com/chkml23s.zip",NULL,NULL,SW_MINIMIZE);
}

//    "" <>
void CChkmailDlg::OnResume() 
{
	ShowWindow(SW_HIDE);
}

void CChkmailDlg::OnConfig()
{
	//  
	CConfigSheet cfgdlg("");
	//    <>
	if( cfgdlg.DoModal()==IDCANCEL )
		return;
	
	UpdateData();

	m_server=((CConncfgPage*)cfgdlg.GetPage(0))->m_server;
	m_user=((CConncfgPage*)cfgdlg.GetPage(0))->m_user;
	m_pass=((CConncfgPage*)cfgdlg.GetPage(0))->m_pass;
	m_timeout=((CConncfgPage*)cfgdlg.GetPage(0))->m_timeout*1000;
	m_portPOP=((CConncfgPage*)cfgdlg.GetPage(0))->m_portPOP;
	AfxGetApp()->WriteProfileString("Setting","server",m_server);
	AfxGetApp()->WriteProfileString("Setting","user",m_user);
	AfxGetApp()->WriteProfileString("Setting","pass",m_pass);
	AfxGetApp()->WriteProfileInt("Setting","portPOP",m_portPOP);
	AfxGetApp()->WriteProfileInt("Setting","timeout",m_timeout);

	m_serverSmtp=((CSendcfgPage*)cfgdlg.GetPage(1))->m_serverSmtp;
	m_portSmtp=((CSendcfgPage*)cfgdlg.GetPage(1))->m_portSmtp;
	m_forward=((CSendcfgPage*)cfgdlg.GetPage(1))->m_forward;
	m_address=((CSendcfgPage*)cfgdlg.GetPage(1))->m_address;
	m_pager=((CSendcfgPage*)cfgdlg.GetPage(1))->m_pager;
	m_pageraddress=((CSendcfgPage*)cfgdlg.GetPage(1))->m_pageraddress;
	m_pagerid=((CSendcfgPage*)cfgdlg.GetPage(1))->m_pagerid;
	AfxGetApp()->WriteProfileString("Setting","serverSmtp",m_serverSmtp);
	AfxGetApp()->WriteProfileInt("Setting","portSmtp",m_portSmtp);
	AfxGetApp()->WriteProfileInt("Setting","forward",m_forward);
	AfxGetApp()->WriteProfileString("Setting","forward address",m_address);
	AfxGetApp()->WriteProfileInt("Setting","pager",m_pager);
	AfxGetApp()->WriteProfileString("Setting","pager address",m_pageraddress);
	AfxGetApp()->WriteProfileString("Setting","pagerid",m_pagerid);


	m_wave=((CAddoptPage*)cfgdlg.GetPage(2))->m_wave;
	m_shedprog=((CAddoptPage*)cfgdlg.GetPage(2))->m_shedprog;
	m_command=((CAddoptPage*)cfgdlg.GetPage(2))->m_command;
	

	AfxGetApp()->WriteProfileString("Setting","sound",m_wave);
	AfxGetApp()->WriteProfileString("Setting","command",m_command);
	AfxGetApp()->WriteProfileString("Setting","shedprog",m_shedprog);	
	AfxGetApp()->WriteProfileInt("Setting","writelog",m_writelog);
	AfxGetApp()->WriteProfileString("Setting","log-file",m_logfile);

	/*  -  ,   */
	if( m_writelog==((CAddoptPage*)cfgdlg.GetPage(2))->m_writelog &&
			m_logfile==((CAddoptPage*)cfgdlg.GetPage(2))->m_logfile )
	{
		SetTimer(2,m_timeout,NULL);
		return;
	}

	m_writelog=((CAddoptPage*)cfgdlg.GetPage(2))->m_writelog;
	m_logfile=((CAddoptPage*)cfgdlg.GetPage(2))->m_logfile;
	AfxGetApp()->WriteProfileInt("Setting","writelog",m_writelog);
	AfxGetApp()->WriteProfileString("Setting","log-file",m_logfile);

	if (logfile.m_pStream != NULL)
	{
		logfile.Close();
		::DeleteFile(m_logfile);
	}

	if( m_writelog )
		{
	CFileException e;
	if( !logfile.Open(m_logfile,CFile::modeCreate|CFile::modeReadWrite,&e) )
		e.ReportError();
	else
		logfile.SeekToEnd();
		
	}
	/*
		if( logfile.m_hFile != CFile::hFileNull )
		{
				logfile.Close();
				logfile.m_hFile=CFile::hFileNull;
		}*/
	

	SetTimer(2,m_timeout,NULL);

}

void CChkmailDlg::WriteLog(CString logrecord,BOOL writetime)
{
	if (logfile.m_pStream == NULL)
		return;

	if( writetime )
	{
		COleDateTime dt=COleDateTime::GetCurrentTime();
		m_string=dt.Format("%d.%m.%Y %H:%M:%S ");
		m_string=m_string+logrecord;	
	}
	else
	{
		m_string=logrecord;
	}

	logfile.WriteString(m_string+'\n');
}

void CChkmailDlg::ViewLog()
{
	if( logfile.m_hFile!=CFile::hFileNull)
		logfile.Close();

	CViewLogDlg ldlg;
	ldlg.DoModal();

	if( m_writelog && ! m_logfile.IsEmpty() )
	{
		CFileException e;
		if( !logfile.Open(m_logfile,CFile::modeCreate|CFile::modeNoTruncate|
			CFile::modeWrite|CFile::shareDenyNone,&e) )
				e.ReportError();
		else
			logfile.SeekToEnd();
	}
}

void CChkmailDlg::LoadSetting()
{
	m_server=AfxGetApp()->GetProfileString("Setting","server","");
	m_portPOP=AfxGetApp()->GetProfileInt("Setting","portPOP",110);
	m_user=AfxGetApp()->GetProfileString("Setting","user","");
	m_pass=AfxGetApp()->GetProfileString("Setting","pass","");
	m_timeout=AfxGetApp()->GetProfileInt("Setting","timeout",60000);

	m_serverSmtp=AfxGetApp()->GetProfileString("Setting","serverSmtp","");
	m_portSmtp=AfxGetApp()->GetProfileInt("Setting","portSmtp",25);
	m_forward=AfxGetApp()->GetProfileInt("Setting","forward",0);
	m_address=AfxGetApp()->GetProfileString("Setting","forward address","");
	m_pager=AfxGetApp()->GetProfileInt("Setting","pager",0);
	m_pageraddress=AfxGetApp()->GetProfileString("Setting","pager address","");
	m_pagerid=AfxGetApp()->GetProfileString("Setting","pagerid","");
	
	m_wave=AfxGetApp()->GetProfileString("Setting","sound","");
	m_command=AfxGetApp()->GetProfileString("Setting","command","");
	m_shedprog=AfxGetApp()->GetProfileString("Setting","shedprog","");
	m_writelog=AfxGetApp()->GetProfileInt("Setting","writelog",1);
	m_logfile=AfxGetApp()->GetProfileString("Setting","log-file","c:\\chkmail.log");

	if( m_writelog && ! m_logfile.IsEmpty() )
	{
		CFileException e;
		if( !logfile.Open(m_logfile,CFile::modeCreate|/*CFile::modeNoTruncate|*/
			CFile::modeWrite|CFile::shareDenyNone,&e) )
				e.ReportError();
		else
			logfile.SeekToEnd();
	}
	else
	{
		logfile.m_hFile=CFile::hFileNull;
	}
}
